VCMD0028040000000000COMPONENT          
Node "rSimResource"
{
Name "Succioncup+grabber"
Id 1
NodeClass 
{
Id 1
Feature "rFrameFeature"
{
Name "MountFrame"

Visible 1
Value 1 0 0 0 0 1 0 0 0 0 1 0 0 0 0 1 
UseAsGuide 1
}
Feature "rPrimitiveCylinderFeature"
{
Name "Cylinder"

Visible 1
Material  "aluminium"
{
  Ambient
  {
    Red 0.128000006079674
    Green 0.128000006079674
    Blue 0.128000006079674
  }
  Diffuse
  {
    Red 0.560000002384186
    Green 0.560000002384186
    Blue 0.560000002384186
  }
  Specular
  {
    Color
    {
      Red 0.643999993801117
      Green 0.643999993801117
      Blue 0.643999993801117
    }
    Shininess 0.400000005960464
  }
}

Radius 
{
  Expression "20 {mm}"
}

Height 
{
  Expression "100 {mm}"
}

StartSweep 
{
  Expression "0 {deg}"
}

EndSweep 
{
  Expression "360 {deg}"
}

Sections 
{
  Expression "12"
}

Caps 1
}
VCID "fab802f1-fea8-4bd0-93af-9f7b7430998a"
}
Functionality "rSimKinController"
{
Id 1
Name "ServoController"
Joints
{
  JointInfo
  {
    Index 0
    DofObject "J1"
  }
}
DummyDofs
{
}
UseHeartbeat 0
HeartRate 0
UsePhysicalHeartbeat 0
RootNode "Succioncup+grabber"
FlangeNode "Link_1"
}
Functionality "rSimInterface"
{
Id 2
Name "EOAT_MountInterface"
Flags 6
Section 
{
Name "MountSection"
Frame "MountFrame"
Fields
{
rSimHierarchyField
{
Name "pnp"
Mount 0
Node "Succioncup+grabber"
Frame "MountFrame"
}
}
}
}
Functionality "rPythonScript"
{
Id 3
Name "ServoController_Script"
Script "from vcScript import *\ncomp = getComponent()\nservo = comp.findBehaviour('ServoController')\n\ndef OnSignal( signal ):\n  global queue\n  if '_ActionSignal' in signal.Name:\n    joint_name = signal.Name.replace('_ActionSignal','')\n    queue.append( [joint_name, signal.Value] )\n\ndef OnRun():\n  global queue\n  queue = []\n  joint_map = {}\n  for i,j in enumerate(servo.Joints):\n    joint_name = j.Name\n    joint_map[joint_name] = i\n    open_state_signal = comp.findBehaviour(joint_name + '_OpenState')\n    closed_state_signal = comp.findBehaviour(joint_name + '_ClosedState')\n    min_val_prop = comp.getProperty(joint_name+'_Closed')\n    max_val_prop = comp.getProperty(joint_name+'_Open')\n    # set init values for state signals\n    if all([min_val_prop, max_val_prop, closed_state_signal, open_state_signal]):\n      if j.CurrentValue == min_val_prop.Value:\n        closed_state_signal.signal(True)\n      else:\n        closed_state_signal.signal(False)\n      if j.CurrentValue == max_val_prop.Value:\n        open_state_signal.signal(True)\n      else:\n        open_state_signal.signal(False)\n\n    \n  while True:\n    condition(lambda: queue)\n    task = queue.pop(0)\n    joint_name, val = task\n    open_state_signal = comp.findBehaviour(joint_name + '_OpenState')\n    closed_state_signal = comp.findBehaviour(joint_name + '_ClosedState')\n    if val == True:\n      # Close\n      min_val = comp.getProperty(joint_name+'_Closed').Value\n      open_state_signal.signal(False)\n      joint_index = joint_map[joint_name]\n      servo.moveJoint(joint_index, min_val)\n      closed_state_signal.signal(True)\n    elif val == False:\n      # Open\n      max_val = comp.getProperty(joint_name+'_Open').Value\n      closed_state_signal.signal(False)\n      joint_index = joint_map[joint_name]\n      servo.moveJoint(joint_index, max_val)\n      open_state_signal.signal(True)\n"
CompatibilityMode 0
}
Functionality "rSimBoolSignal"
{
Id 4
Name "J1_ActionSignal"
Connections
{
"ServoController_Script"
}
}
Functionality "rSimBoolSignal"
{
Id 5
Name "J1_OpenState"
Connections
{
}
}
Functionality "rSimBoolSignal"
{
Id 6
Name "J1_ClosedState"
Connections
{
}
}
VCID fab802f1-fea8-4bd0-93af-9f7b7430998a
Revision 3
Location 1 0 0 0 0 1 0 0 0 0 1 0 0 0 0 1 
ActiveSimulationLevel detailed
BOMname  "Succioncup+grabber"

BOMdescription  "Succioncup+grabber"

Category  ""

VariableSpace ""
{
  Variable "rTVariable<rBool>"
  {
    Name "Visible"
    Value 1
    Group -1130
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      MANAGED
    }
  }
  Variable "rTVariable<rDouble>"
  {
    Name "J1_Open"
    Value 100
    Group 20
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
    }
  }
  Variable "rTVariable<rDouble>"
  {
    Name "J1_Closed"
    Value 0
    Group 30
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
    }
  }
}
Node "rSimLink"
{
Name "Link_1"
Id 2
NodeClass 
{
Id 2
Feature "rFrameFeature"
{
Name "FrameHigh"

Visible 1
Value 1 0 0 0 0 1 0 0 0 0 1 0 34.1871391827 33.2686698568 180 1 
UseAsGuide 1
}
Feature "rFrameFeature"
{
Name "FrameLow"

Visible 1
Value 1 0 0 0 0 1 0 0 0 0 1 0 -33.0720301589 -34.4396460593 130 1 
UseAsGuide 1
}
Feature "rPrimitiveConeFeature"
{
Name "Cone"

Matrix 1 0 0 0 0 1 0 0 0 0 1 0 9.53674316406e-007 -4.76837158203e-007 110 1 
Visible 1
Material  "blue_matte"
{
  Ambient
  {
    Red 0.0350000001490116
    Green 0.0350000001490116
    Blue 0.234999999403954
  }
  Diffuse
  {
    Red 0.140000000596046
    Green 0.140000000596046
    Blue 0.939999997615814
  }
  Specular
  {
    Color
    {
      Red 0.0700000002980232
      Green 0.0700000002980232
      Blue 0.469999998807907
    }
    Shininess 0.0599999986588955
  }
}

BottomRadius 
{
  Expression "10 {mm}"
}

TopRadius 
{
  Expression "50 {mm}"
}

Height 
{
  Expression "20"
}

StartSweep 
{
  Expression "0 {deg}"
}

EndSweep 
{
  Expression "360 {deg}"
}

Sections 
{
  Expression "12"
}

Caps 1
}
Feature "rPrimitiveCylinderFeature"
{
Name "Cylinder_1"

Visible 1
Material  "black_metallic"
{
  Ambient
  {
    Red 0.00575000001117587
    Green 0.00575000001117587
    Blue 0.00575000001117587
  }
  Diffuse
  {
    Red 0.0274999998509884
    Green 0.0274999998509884
    Blue 0.0274999998509884
  }
  Specular
  {
    Color
    {
      Red 0.859749972820282
      Green 0.859749972820282
      Blue 0.859749972820282
    }
    Shininess 0.899999976158142
  }
}

Radius 
{
  Expression "10"
}

Height 
{
  Expression "110 {mm}"
}

StartSweep 
{
  Expression "0 {deg}"
}

EndSweep 
{
  Expression "360 {deg}"
}

Sections 
{
  Expression "12"
}

Caps 1
}
}
Functionality "rSimBoolSignal"
{
Id 7
Name "GraspTrigger"
Connections
{
}
}
Functionality "rSimBoolSignal"
{
Id 8
Name "ReleaseTrigger"
Connections
{
}
}
Functionality "rSimBoolSignal"
{
Id 9
Name "INGraspReleaseAction"
Connections
{
}
}
Functionality "rSimBoolSignal"
{
Id 10
Name "OUTGraspReleaseInfo"
Connections
{
}
}
Functionality "rSimResourcePtrSignal"
{
Id 11
Name "ComponentSignal"
Connections
{
}
}
Functionality "rSimVolumeSensor"
{
Id 12
Name "GraspSensor"
Flags 2
FrameLower "FrameLow"
FrameUpper "FrameHigh"
TransformUpdate 1
ShowVolume 1
Sampling 1
SampleFrequency 0.01
VolumeMaterial  "glass3"
{
  Ambient
  {
    Red 0.25
    Green 0.25
    Blue 0.25
  }
  Diffuse
  {
    Red 1
    Green 1
    Blue 1
  }
  Specular
  {
    Color
    {
      Red 1
      Green 1
      Blue 1
    }
    Shininess 1
  }
  Transparency
  {
    Constant
    Value 0.100000001490116
  }
}

AllHits 0
TestOnlyContained 0
TestSiblings 0
TestParent 0
}
Functionality "rSimVolumeSensor"
{
Id 13
Name "ReleaseSensor"
Flags 2
FrameLower "FrameLow"
FrameUpper "FrameHigh"
TransformUpdate 1
ShowVolume 1
Sampling 1
SampleFrequency 0.01
VolumeMaterial  "glass3"

AllHits 0
TestOnlyContained 0
TestSiblings 0
TestParent 0
}
Dof  "Translational"
{
  Name "J1"
  Properties
  {
    Variable "rTExpressionVariable<rDouble>"
    {
      Name "SoftMinLimit"
      Value
      {
        Expression ""
      }
      Group 33
      Settings
      {
        VISIBLE
        EDITABLE_DISCONNECTED
        EDITABLE_CONNECTED
        EDITABLE_SIMULATING
      }
    }
    Variable "rTExpressionVariable<rDouble>"
    {
      Name "SoftMaxLimit"
      Value
      {
        Expression ""
      }
      Group 34
      Settings
      {
        VISIBLE
        EDITABLE_DISCONNECTED
        EDITABLE_CONNECTED
        EDITABLE_SIMULATING
      }
    }
    Variable "rTVariable<rDouble>"
    {
      Name "MaxSpeed"
      Value 100
      Group 35
      Settings
      {
        VISIBLE
        EDITABLE_DISCONNECTED
        EDITABLE_CONNECTED
        EDITABLE_SIMULATING
        TRANSLATE_USING_GETTEXT
      }
    }
    Variable "rTVariable<rDouble>"
    {
      Name "MaxAcceleration"
      Value 500
      Group 36
      Settings
      {
        VISIBLE
        EDITABLE_DISCONNECTED
        EDITABLE_CONNECTED
        EDITABLE_SIMULATING
        TRANSLATE_USING_GETTEXT
      }
    }
    Variable "rTVariable<rDouble>"
    {
      Name "MaxDeceleration"
      Value 500
      Group 37
      Settings
      {
        VISIBLE
        EDITABLE_DISCONNECTED
        EDITABLE_CONNECTED
        EDITABLE_SIMULATING
        TRANSLATE_USING_GETTEXT
      }
    }
    Variable "rTVariable<rDouble>"
    {
      Name "LagTime"
      Value 0
      Group 41
      Settings
      {
        VISIBLE
        EDITABLE_DISCONNECTED
        EDITABLE_CONNECTED
        EDITABLE_SIMULATING
        TRANSLATE_USING_GETTEXT
      }
    }
    Variable "rTVariable<rDouble>"
    {
      Name "SettleTime"
      Value 0
      Group 42
      Settings
      {
        VISIBLE
        EDITABLE_DISCONNECTED
        EDITABLE_CONNECTED
        EDITABLE_SIMULATING
        TRANSLATE_USING_GETTEXT
      }
    }
  }
  JointValue 0
  MinLimit
  {
    Expression "0"
  }
  MaxLimit
  {
    Expression "100"
  }
  AxisType 2
  JointDeflection
  {
    Expression "VALUE"
  }
}
Offset 
{
  Expression ""
}
}
}
